#!/usr/bin/env python

import SimpleHTTPServer
import SocketServer

import os
import posixpath
import BaseHTTPServer
import urllib
import urlparse
import cgi
import sys
import shutil
import mimetypes
try:
    from cStringIO import StringIO
except ImportError:
    from StringIO import StringIO

import datetime
import time

import argparse

import socket # For gethostbyaddr()

#import mimetools

import dis

FlPrice = 17.
FlTrFee = 3.3
Transactions = {}

class Handler(SimpleHTTPServer.SimpleHTTPRequestHandler):

    def list_directory(self, path):
        """Helper to produce a directory listing (absent index.html).

        Return value is either a file object, or None (indicating an
        error).  In either case, the headers are sent, making the
        interface the same as for send_head().

        """
        try:
            list = os.listdir(path)
        except os.error:
            self.send_error(404, "No permission to list directory")
            return None
        list.sort(key=lambda a: a.lower())
        f = StringIO()
        displaypath = cgi.escape(urllib.unquote(self.path))
        f.write('<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">')
        f.write("<html>\n<title>Directory listing 4 %s</title>\n" % displaypath)
        f.write("<body>\n<h2>The <a href=\"https://bitcointalk.org/index.php?board=90.0\">Electrum plugin</a> is needed %s</h2>\n" % displaypath)
        f.write("<hr>\n<ul>\n")
        f.write("<table border=\"1\"> <tr> <th>Name</th><th>Size</th><th>Modify time</th> <th>Price mBTC</th>  <th>Tr Fee mBTC/kB </th> </tr>")
        for name in list:
            fullname = os.path.join(path, name)
            displayname = linkname = name
            filesize = ""
            HFlPrice = ""
            HFlTrFee = ""
            
            # Append / for directories or @ for symbolic links
            if os.path.isdir(fullname):
                displayname = name + "/"
                linkname = name + "/"
            else:
                filesize = str(os.path.getsize(fullname))
                HFlPrice = FlPrice
                HFlTrFee = FlTrFee
            if os.path.islink(fullname):
                displayname = name + "@"
                # Note: a link to a directory displays with @ and links with /
                
            f.write('<tr><td><li><a href="%s">%s</a></td><td>%s</td><td>%s</td><td>%s</td><td>%s</td></tr>\n'
                    % (urllib.quote(linkname), cgi.escape(displayname), filesize ,
                       str(datetime.datetime.fromtimestamp(os.path.getmtime(fullname))) , HFlPrice , HFlTrFee  ) )
        f.write("</table></ul>\n<hr>\n</body>\n</html>\n")
        length = f.tell()
        f.seek(0)
        self.send_response(200)
        encoding = sys.getfilesystemencoding()
        self.send_header("Content-type", "text/html; charset=%s" % encoding)
        self.send_header("Content-Length", str(length))
        self.end_headers()
        return f

    def TransactionTst(self):
        return 1
    
    def do_PUT(self):
        self.wfile.write("ok\r\n")
        csum = 0
        for char in self.BTCTransaction:
            csum += ord(char)
        print("mmoTransaction=",self.BTCTransaction,csum)
        Transactions[csum]=self.TransactionTst()
        

    def handle_one_request(self):
        """Handle a single HTTP request.

        You normally don't need to override this method; see the class
        __doc__ string for information on how to handle specific HTTP
        commands such as GET and POST.

        """
        try:
            print("rfile.readline")
            self.raw_requestline = self.rfile.readline(65537)
            print("nextL0=",self.raw_requestline)
            if len(self.raw_requestline) > 65536:
                self.requestline = ''
                self.request_version = ''
                self.command = ''
                self.send_error(414)
                return
            count = 1
            
            words = self.raw_requestline.split('$')
            self.command = ""
            if len(words) == 2:
                self.command , self.BTCTransaction = words
                self.BTCTransaction = self.BTCTransaction.rstrip()
            if self.command == "PUT":
                self.do_PUT()
                self.close_connection = 1
                return
            
            if not self.raw_requestline:
                self.close_connection = 1
                return
            if not self.parse_request():
                # An error code has been sent, just exit
                return
            mname = 'do_' + self.command
            if not hasattr(self, mname):
                self.send_error(501, "Unsupported method (%r)" % self.command)
                return
            method = getattr(self, mname)
            method()
            self.wfile.flush() #actually send the response if not already done.
        except socket.timeout, e:
            #a read or a write timed out.  Discard this connection
            self.log_error("Request timed out: %r", e)
            self.close_connection = 1
            return

    def send_head(self):
        """Common code for GET and HEAD commands.

        This sends the response code and MIME headers.

        Return value is either a file object (which has to be copied
        to the outputfile by the caller unless the command was HEAD,
        and must be closed by the caller under all circumstances), or
        None, in which case the caller has nothing further to do.

        """
        for name, value in self.headers.items():
            print('mmo%s=%s' % (name, value.rstrip()))
        path = self.translate_path(self.path)
        f = None
        print("mmopath=<",path,">")
        if os.path.isdir(path):
            parts = urlparse.urlsplit(self.path)
            return self.list_directory(path)
            
        print("mmoself.path=<",self.path,">")
        if len(self.path) < 8 :
            self.wfile.write("HTTP/1.1 303 See Other\nLocation: http://localhost:8120"+self.path)
            self.wfile.write("\nContent-Length: 0\nConnection: close\n\n")
            self.close_connection = 1
            return f

        if self.path!='/favicon.ico' :
            if self.path[1+8] != "$" : #False:
                # Address to the local buyer
                self.wfile.write("HTTP/1.1 303 See Other\nLocation: http://localhost:8120"+self.path)
                self.wfile.write("\nContent-Length: 0\nConnection: close\n\n")
                #self.end_headers()
                self.close_connection = 1
                return f
             
            if self.path[1+8] == "$" :
                if self.path[1:9]=='giveparm': # What transaction do you need?
                    self.wfile.write("%s;%s;%s\r\n"%(FlPrice,FlTrFee,time.mktime(time.gmtime())))
                    #self.close_connection = 1
                    return f
            
            try:
                print('IDTransactions=',self.path[1:9])
                IDTran = int(self.path[1:9],base=16)
                for char in self.path[10:]:
                    IDTran -= ord(char)

                print('Transactions=',Transactions[IDTran])
                
            except KeyError:
                self.send_error(404, "Transaction not found")
                return None
            
            
            self.path= self.path.split('$')[1]
            path = self.translate_path(self.path)           
        ctype = self.guess_type(path)
        print("mmoopen.path=<",path,">")

        try:
            # Always read in binary mode. Opening files in text mode may cause
            # newline translations, making the actual size of the content
            # transmitted *less* than the content-length!
            f = open(path, 'rb')
        except IOError:
            self.send_error(404, "File not found")
            return None
        try:
            self.send_response(200)
            self.send_header("Content-type", ctype)
            fs = os.fstat(f.fileno())
            self.send_header("Content-Length", str(fs[6]))
            self.send_header("Last-Modified", self.date_time_string(fs.st_mtime))
            self.end_headers()
            return f
        except:
            f.close()
            raise

parser = argparse.ArgumentParser()
parser.add_argument('--port', '-p', default=8000, type=int)

args = parser.parse_args()

print("Server listening on port %d...", args.port )
httpd = SocketServer.TCPServer(('', args.port), Handler)

os.chdir('..')
httpd.serve_forever()

